---------------------------------------------------------------
-- Server-side Paging
---------------------------------------------------------------

USE AdventureWorks2012
GO

-- Get 10 rows starting at row 21 (rows 21-30; i.e., page 3)

-- Using ROW_NUMBER introduced in SQL Server 2005
DECLARE @PageNum int = 3
DECLARE @PageSize int = 10
DECLARE @FirstRow int = ((@PageNum - 1) * @PageSize) + 1
DECLARE @LastRow int = @FirstRow + @PageSize - 1

SELECT *
 FROM
   (SELECT
     RowNum = ROW_NUMBER() OVER (ORDER BY LastName, FirstName),
     Title, FirstName, LastName
    FROM
     Person.Person
    ) AS a
 WHERE RowNum BETWEEN @firstRow AND @lastRow
 ORDER BY LastName, FirstName
GO

-- Using OFFSET/FETCH NEXT in Denali
DECLARE @PageNum int = 3
DECLARE @PageSize int = 10
DECLARE @Offset int = (@PageNum - 1) * @PageSize

SELECT Title, FirstName, LastName
 FROM Person.Person
 ORDER BY LastName, FirstName
  OFFSET @Offset ROWS FETCH NEXT @PageSize ROWS ONLY

GO
