﻿using System;
using System.Data;
using System.Data.SqlClient;
using System.Transactions;

namespace DistributedTrans
{
  class Program
  {
    static void Main(string[] args)
    {
      const string ConnStr1 =
       "Data Source=(local);Initial Catalog=Test1;Integrated Security=SSPI;";
      const string ConnStr2 =
       "Data Source=(local);Initial Catalog=Test2;Integrated Security=SSPI;";

      const string CmdText1 = "UPDATE FromTable SET Amount = Amount - 50";
      const string CmdText2 = "UPDATE ToTable SET Amount = Amount + 50";

      using (var tsc = new TransactionScope())
      {
        using (var conn1 = new SqlConnection(ConnStr1))
        {
          SqlCommand cmd1 = conn1.CreateCommand();
          cmd1.CommandText = CmdText1;
          conn1.Open();
          cmd1.ExecuteNonQuery();
        }

        // Operation #1 is done, going to Operation #2

        using (var conn2 = new SqlConnection(ConnStr2))
        {
          SqlCommand cmd2 = conn2.CreateCommand();
          cmd2.CommandText = CmdText2;
          conn2.Open();
          cmd2.ExecuteNonQuery();
        }

        tsc.Complete();
      }
    }
  }
}
