﻿using System;
using System.ComponentModel;

namespace FlixPoll.LocalData
{
    public class Quiz : INotifyPropertyChanged
    {
        private int _responseId;
        private int _inquiryId;
        private int _movieId;
        private string _question;
        private bool _answer;

        public int ResponseId
        {
            get
            {
                return this._responseId;
            }
            set
            {
                if (this._responseId != value)
                {
                    this._responseId = value;
                    NotifyPropertyChanged("ResponseId");
                }
            }
        }

        public int InquiryId
        {
            get
            {
                return this._inquiryId;
            }
            set
            {
                if (this._inquiryId != value)
                {
                    this._inquiryId = value;
                    NotifyPropertyChanged("InquiryId");
                }
            }
        }

        public int MovieId
        {
            get
            {
                return this._movieId;
            }
            set
            {
                if (this._movieId != value)
                {
                    this._movieId = value;
                    NotifyPropertyChanged("MovieId");
                }
            }
        }

        public string Question
        {
            get
            {
                return this._question;
            }
            set
            {
                if (this._question != value)
                {
                    this._question = value;
                    NotifyPropertyChanged("Question");
                }
            }
        }

        public bool Answer
        {
            get
            {
                return this._answer;
            }
            set
            {
                if (this._answer != value)
                {
                    this._answer = value;
                    NotifyPropertyChanged("Answer");
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }

    }
}
